"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Left = exports.Right = exports.left = exports.right = exports.toEither = void 0;
var option_1 = require("./option");
function toEither(cb) {
    try {
        return right(cb());
    }
    catch (e) {
        return left(e);
    }
}
exports.toEither = toEither;
function right(v) {
    return new Right(v);
}
exports.right = right;
function left(err) {
    return new Left(err);
}
exports.left = left;
var Right = /** @class */ (function () {
    function Right(v) {
        this.v = v;
        this.err = undefined;
        this.get = this.v;
        this.isRight = true;
        this.isLeft = false;
        this.toOpt = (0, option_1.some)(this.v);
    }
    Object.defineProperty(Right.prototype, "getErr", {
        get: function () {
            throw new Error("Right has no error");
        },
        enumerable: false,
        configurable: true
    });
    Right.prototype.map = function (f) {
        return right(f(this.v));
    };
    Right.prototype.flatMap = function (f) {
        return f(this.v);
    };
    Right.prototype.mapErr = function () {
        return right(this.v);
    };
    Right.prototype.flatMapErr = function () {
        return right(this.v);
    };
    return Right;
}());
exports.Right = Right;
var Left = /** @class */ (function () {
    function Left(err) {
        this.err = err;
        this.v = undefined;
        this.isRight = false;
        this.isLeft = true;
        this.getErr = this.err;
        this.toOpt = (0, option_1.none)();
    }
    Object.defineProperty(Left.prototype, "get", {
        get: function () {
            throw new Error("Left has no value");
        },
        enumerable: false,
        configurable: true
    });
    Left.prototype.map = function () {
        return left(this.err);
    };
    Left.prototype.flatMap = function () {
        return left(this.err);
    };
    Left.prototype.mapErr = function (f) {
        return left(f(this.err));
    };
    Left.prototype.flatMapErr = function (f) {
        return f(this.err);
    };
    return Left;
}());
exports.Left = Left;
//# sourceMappingURL=either.js.map