"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.None = exports.Some = exports.opt = exports.none = exports.some = void 0;
var either_1 = require("./either");
function some(v) {
    return new Some(v);
}
exports.some = some;
function none() {
    return new None();
}
exports.none = none;
function opt(v) {
    if (v == null)
        return none();
    return some(v);
}
exports.opt = opt;
var Some = /** @class */ (function () {
    function Some(v) {
        this.v = v;
        this.isEmpty = false;
        this.isDefined = true;
        this.get = this.v;
    }
    Some.prototype.map = function (f) {
        return some(f(this.v));
    };
    Some.prototype.flatMap = function (f) {
        return f(this.v);
    };
    Some.prototype.getOrThrow = function () {
        return this.v;
    };
    Some.prototype.getOrElse = function () {
        return this.v;
    };
    Some.prototype.orElse = function () {
        return this;
    };
    Some.prototype.fold = function (_, right) {
        return right(this.v);
    };
    Some.prototype.toEither = function () {
        return (0, either_1.right)(this.v);
    };
    return Some;
}());
exports.Some = Some;
var None = /** @class */ (function () {
    function None() {
        this.v = undefined;
        this.isEmpty = true;
        this.isDefined = false;
    }
    None.prototype.map = function () {
        return none();
    };
    None.prototype.flatMap = function () {
        return none();
    };
    Object.defineProperty(None.prototype, "get", {
        get: function () {
            throw new Error("None has no value");
        },
        enumerable: false,
        configurable: true
    });
    None.prototype.getOrThrow = function (err) {
        throw err;
    };
    None.prototype.getOrElse = function (def) {
        return def;
    };
    None.prototype.orElse = function (def) {
        return def;
    };
    None.prototype.fold = function (left) {
        return left();
    };
    None.prototype.toEither = function (err) {
        return (0, either_1.left)(err);
    };
    return None;
}());
exports.None = None;
//# sourceMappingURL=option.js.map